#include <stdio.h>
#include <stdlib.h>

typedef struct stablo
{
	int k, tc;
	struct stablo *levi, *desni;
} stablo;

#define new(x) x = (stablo *)malloc(sizeof(stablo))

void dodaj(stablo **p, int k, int tc)
{
	stablo *pom1, *pom2, *tmp;

	new(tmp);
	tmp->k = k;
	tmp->tc = tc;
	tmp->levi = tmp->desni = NULL;

	if(!(*p)) *p = tmp;
	else
	{
		pom1 = *p;
		while(pom1)
		{
			pom2 = pom1;
			if(tc < pom1->tc) pom1 = pom1->levi;
			else pom1 = pom1->desni;
		}

		if(tc < pom2->tc) pom2->levi = tmp;
		else pom2->desni = tmp;
	}
}

stablo *form()
{
	stablo *p = NULL;
	int i, n, k, tc;

	scanf("%d", &n);
	getchar();

	for(i = 0; i < n; i++)
	{
		scanf("%d", &k);
		tc = (k / 100) % 10;
		dodaj(&p, k, tc);
	}
	return p;
}

void ispis(stablo *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%d  %d  ", p->k, p->tc);
		ispis(p->levi);
	}
}

void nadji(stablo *p, int *i, int x)
{
	if(p)
	{
		nadji(p->levi, i, x);
		if((p->k < x) && ((p->tc > 2) && (p->tc < 8))) (*i) += 1;
		nadji(p->desni, i, x);
	}
}

main()
{
	stablo *p;
	int i, x;

	p = form();
	ispis(p);
	printf("\n");

	scanf("%d", &x);
	getchar();

	nadji(p, &i, x);
	printf("Ima %d. brojeva koji su manji od X, i cifra im je izmedju 2 i 8\n", i);
}
