#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define novi(x) x=(struct destinacija*)malloc(sizeof(struct destinacija))

typedef struct destinacija
{
	char *naziv;
	int udaljenost;
	struct destinacija *sled;
}Destinacija;

void dodaj(Destinacija **p, char *naziv, int broj)
{
	Destinacija *temp, *poc, *tek;
	novi(temp);
	temp->naziv = (char*)malloc(strlen(naziv)+1);
	strcpy(temp->naziv, naziv);
	temp->udaljenost = broj;
	if(!(*p))
	{
		*p = temp;
		temp->sled = temp;
	}
	else
	{
		poc = *p;
		if (poc->sled)
		{	
			 tek = poc;
			 while(poc != tek->sled) tek = tek->sled;
			 tek->sled = temp;			 
 			 temp->sled = poc;			 
		}
		*p = poc;	
	}
}

Destinacija* form()
{
	char *naziv;
	Destinacija *p = NULL;
	int udaljenost;
	naziv = (char*)malloc(sizeof(char*));
	printf("Unesi naziv: \n");
	scanf("%s", naziv);
	while (strcmp(naziv,"OKRUG") != 0)
	{
		printf("Unesi udaljenost: \n");
		scanf("%d", &udaljenost);
		dodaj(&p, naziv, udaljenost);
		printf("Unesi naziv: \n");		
		scanf("%s", naziv);	
	}
}

void ispis(Destinacija *p)
{
	Destinacija *poc;
	if(p)
	{
		
		poc = p;
		while(poc != p->sled)
		{
			printf("%s \n", p->naziv);
			printf("%d \n", p->udaljenost);
			p = p->sled;
		}
	}
}

main()
{
	Destinacija *p;
	p = form();
	ispis(p);
}
